Listing 1 -- A suite of functions that deal with command-line
arguments. ArgSet() fills a static array with all arguments
passed on the command line. IsArgument() can be called from
anywhere in your program.

   #include "artful.ch"

   FUNCTION TEST( p1, p2, p3, p4, p5, p6, p7, p8, p9, p10 )
   LOCAL i := 1, j

   ArgSet( { p1, p2, p3, p4, p5, p6, p7, p8, p9, p10  } )
   j := ArgCount()

   CLEAR SCREEN
   ? "Number of command-line parameters: ", ArgCount()
   ? "                     Color toggle: ", IF( IS_COLOR(), "ON", "OFF" )
   FOR i = 1 TO j
       ? Argument( i )
   NEXT
   WAIT


   This function suite, as with much else, was inspired by a
   conversation with Mike Schinkel.

*/

STATIC ArgList:= {}

/* the functions proper */

* 
FUNCTION ArgSet( aParams )
* 
LOCAL nArgs := Len( aParams )
LOCAL i     := 1
ArgList     := aParams

FOR i = nArgs TO 1 STEP -1
   IF ( ArgList[ i ] == NIL )
      nArgs--
   ELSE
      EXIT
   ENDIF
NEXT
ASize( ArgList, nArgs )
RETURN NIL


* 
FUNCTION ArgCount()
* 
RETURN Len( ArgList )


* 
FUNCTION Argument( nArgNo )
* 
RETURN ( IF( LEN( ArgList ) < nArgNo, NIL, ArgList[ nArgNo ] ) )


* 
FUNCTION IsArgument( cArg )
* 
RETURN AScan( ArgList, {| a | UPPER(a) == UPPER(cArg) } ) > 0


